package com.logicbig.example;

import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.annotation.ClassPathScanningCandidateComponentProvider;
import org.springframework.core.convert.converter.ConditionalGenericConverter;
import org.springframework.core.convert.converter.GenericConverter;
import org.springframework.core.type.filter.AssignableTypeFilter;
import java.util.Set;

public class SpringBuiltInGenericConvertersFinder {
    public static void main(String[] args) {
        ClassPathScanningCandidateComponentProvider provider =
                new ClassPathScanningCandidateComponentProvider(false);
        provider.addIncludeFilter(new AssignableTypeFilter(GenericConverter.class));
        provider.addExcludeFilter(new AssignableTypeFilter(ConditionalGenericConverter.class));
        Set<BeanDefinition> components = provider.findCandidateComponents("org/springframework");
        components.stream()
                  .map(BeanDefinition::getBeanClassName)
                  .forEach(System.out::println);
    }
}